/*
 * Blockdaemon REST API
 *
 * Blockdaemon REST API provides a RESTful and uniform way to access blockchain resources, with a rich and reusable model across multiple protocols/cryptocurrencies.  [Documentation](https://docs.blockdaemon.com/reference/rest-api-overview)  ### Currently supported protocols:  * algorand   * mainnet * avalanche    * mainnet-c/testnet-c * bitcoin   * mainnet/testnet * bitcoincash   * mainnet/testnet * dogecoin   * mainnet/testnet * ethereum   * mainnet/holesky/sepolia * fantom   * mainnet/testnet * litecoin   * mainnet/testnet * near   * mainnet * optimism   * mainnet * polkadot   * mainnet/westend * polygon   * mainnet/amoy * solana   * mainnet/testnet * stellar   * mainnet/testnet * tezos   * mainnet * tron   * mainnet/nile * xrp   * mainnet  ### Pagination Certain resources contain a lot of data, more than what's practical to return for a single request. With the help of pagination, the data is split across multiple responses. Each response returns a subset of the items requested, and a continuation token.  To get the next batch of items, copy the returned continuation token to the continuation query parameter and repeat the request with the new URL. In case no continuation token is returned, there is no more data available.
 *
 * API version: 3.0.0
 * Contact: support@blockdaemon.com
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package ubiquity

import (
	"encoding/json"
)

// TxCreateEvm EVM specific parameters for transaction creation.
type TxCreateEvm struct {
	// Gas of transaction. If omitted, the gas will be estimated using eth_estimateGas.
	Gas *int64 `json:"gas,omitempty"`
	// The max priority fee per gas. Also referred to as the miner tip. When omitted an estimate will be used.
	MaxPriorityFeePerGas *int64 `json:"maxPriorityFeePerGas,omitempty"`
	// The max fee per gas, this includes the base fee and max priority fee per gas. When omitted an esitmate will be used.
	MaxFeePerGas *int64 `json:"maxFeePerGas,omitempty"`
}

// NewTxCreateEvm instantiates a new TxCreateEvm object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewTxCreateEvm() *TxCreateEvm {
	this := TxCreateEvm{}
	return &this
}

// NewTxCreateEvmWithDefaults instantiates a new TxCreateEvm object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewTxCreateEvmWithDefaults() *TxCreateEvm {
	this := TxCreateEvm{}
	return &this
}

// GetGas returns the Gas field value if set, zero value otherwise.
func (o *TxCreateEvm) GetGas() int64 {
	if o == nil || o.Gas == nil {
		var ret int64
		return ret
	}
	return *o.Gas
}

// GetGasOk returns a tuple with the Gas field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TxCreateEvm) GetGasOk() (*int64, bool) {
	if o == nil || o.Gas == nil {
		return nil, false
	}
	return o.Gas, true
}

// HasGas returns a boolean if a field has been set.
func (o *TxCreateEvm) HasGas() bool {
	if o != nil && o.Gas != nil {
		return true
	}

	return false
}

// SetGas gets a reference to the given int64 and assigns it to the Gas field.
func (o *TxCreateEvm) SetGas(v int64) {
	o.Gas = &v
}

// GetMaxPriorityFeePerGas returns the MaxPriorityFeePerGas field value if set, zero value otherwise.
func (o *TxCreateEvm) GetMaxPriorityFeePerGas() int64 {
	if o == nil || o.MaxPriorityFeePerGas == nil {
		var ret int64
		return ret
	}
	return *o.MaxPriorityFeePerGas
}

// GetMaxPriorityFeePerGasOk returns a tuple with the MaxPriorityFeePerGas field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TxCreateEvm) GetMaxPriorityFeePerGasOk() (*int64, bool) {
	if o == nil || o.MaxPriorityFeePerGas == nil {
		return nil, false
	}
	return o.MaxPriorityFeePerGas, true
}

// HasMaxPriorityFeePerGas returns a boolean if a field has been set.
func (o *TxCreateEvm) HasMaxPriorityFeePerGas() bool {
	if o != nil && o.MaxPriorityFeePerGas != nil {
		return true
	}

	return false
}

// SetMaxPriorityFeePerGas gets a reference to the given int64 and assigns it to the MaxPriorityFeePerGas field.
func (o *TxCreateEvm) SetMaxPriorityFeePerGas(v int64) {
	o.MaxPriorityFeePerGas = &v
}

// GetMaxFeePerGas returns the MaxFeePerGas field value if set, zero value otherwise.
func (o *TxCreateEvm) GetMaxFeePerGas() int64 {
	if o == nil || o.MaxFeePerGas == nil {
		var ret int64
		return ret
	}
	return *o.MaxFeePerGas
}

// GetMaxFeePerGasOk returns a tuple with the MaxFeePerGas field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TxCreateEvm) GetMaxFeePerGasOk() (*int64, bool) {
	if o == nil || o.MaxFeePerGas == nil {
		return nil, false
	}
	return o.MaxFeePerGas, true
}

// HasMaxFeePerGas returns a boolean if a field has been set.
func (o *TxCreateEvm) HasMaxFeePerGas() bool {
	if o != nil && o.MaxFeePerGas != nil {
		return true
	}

	return false
}

// SetMaxFeePerGas gets a reference to the given int64 and assigns it to the MaxFeePerGas field.
func (o *TxCreateEvm) SetMaxFeePerGas(v int64) {
	o.MaxFeePerGas = &v
}

func (o TxCreateEvm) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Gas != nil {
		toSerialize["gas"] = o.Gas
	}
	if o.MaxPriorityFeePerGas != nil {
		toSerialize["maxPriorityFeePerGas"] = o.MaxPriorityFeePerGas
	}
	if o.MaxFeePerGas != nil {
		toSerialize["maxFeePerGas"] = o.MaxFeePerGas
	}
	return json.Marshal(toSerialize)
}

type NullableTxCreateEvm struct {
	value *TxCreateEvm
	isSet bool
}

func (v NullableTxCreateEvm) Get() *TxCreateEvm {
	return v.value
}

func (v *NullableTxCreateEvm) Set(val *TxCreateEvm) {
	v.value = val
	v.isSet = true
}

func (v NullableTxCreateEvm) IsSet() bool {
	return v.isSet
}

func (v *NullableTxCreateEvm) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableTxCreateEvm(val *TxCreateEvm) *NullableTxCreateEvm {
	return &NullableTxCreateEvm{value: val, isSet: true}
}

func (v NullableTxCreateEvm) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableTxCreateEvm) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
